# Generated by Django 4.1.3 on 2022-12-10 15:20

from django.db import migrations, models
import django.db.models.deletion


# Functions from the following migrations need manual copying.
# Move them and any dependencies into this file, then update the
# RunPython operations to refer to the local versions:
# alerts.migrations.0002_auto_20210314_2022


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        (
            "projects",
            "0001_squashed_0009_alter_project_id_alter_projectcounter_id_and_more",
        ),
    ]

    operations = [
        migrations.CreateModel(
            name="ProjectAlert",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "timespan_minutes",
                    models.PositiveSmallIntegerField(blank=True, null=True),
                ),
                ("quantity", models.PositiveSmallIntegerField(blank=True, null=True)),
                ("created", models.DateTimeField(auto_now_add=True)),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="projects.project",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Notification",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created", models.DateField(auto_now_add=True)),
                ("is_sent", models.BooleanField(default=False)),
                ("issues", models.ManyToManyField(to="issues.Issue")),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="projects.project",
                    ),
                ),
                (
                    "project_alert",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="alerts.projectalert",
                    ),
                ),
            ],
        ),
        migrations.AlterField(
            model_name="notification",
            name="project_alert",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="alerts.projectalert"
            ),
            preserve_default=False,
        ),
        migrations.RemoveField(
            model_name="notification",
            name="project",
        ),
        migrations.AlterField(
            model_name="notification",
            name="created",
            field=models.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="projectalert",
            name="created",
            field=models.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AddField(
            model_name="projectalert",
            name="name",
            field=models.CharField(blank=True, max_length=255),
        ),
        migrations.AddField(
            model_name="projectalert",
            name="uptime",
            field=models.BooleanField(
                default=False,
                help_text="Send alert on any uptime monitor check failure",
            ),
        ),
        migrations.CreateModel(
            name="AlertRecipient",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "recipient_type",
                    models.CharField(
                        choices=[("email", "Email"), ("webhook", "Webhook")],
                        max_length=16,
                    ),
                ),
                ("url", models.URLField(blank=True, max_length=2000)),
                (
                    "alert",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="alerts.projectalert",
                    ),
                ),
            ],
            options={
                "unique_together": {("alert", "recipient_type", "url")},
            },
        ),
        migrations.AlterField(
            model_name="notification",
            name="id",
            field=models.BigAutoField(
                auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
            ),
        ),
        migrations.AlterField(
            model_name="projectalert",
            name="id",
            field=models.BigAutoField(
                auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
            ),
        ),
    ]
