# Generated by Django 5.0.2 on 2024-03-07 17:56

import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


# Functions from the following migrations need manual copying.
# Move them and any dependencies into this file, then update the
# RunPython operations to refer to the local versions:
# apps.teams.migrations.0002_team_members_new


class Migration(migrations.Migration):
    replaces = [
        ("teams", "0001_initial"),
        ("teams", "0002_team_members_new"),
        ("teams", "0003_auto_20200613_2156"),
        ("teams", "0004_alter_team_id_alter_team_members"),
    ]

    initial = True

    dependencies = [
        (
            "organizations_ext",
            "0001_squashed_0003_alter_organization_id_alter_organization_users_and_more",
        ),
        (
            "projects",
            "0001_squashed_0009_alter_project_id_alter_projectcounter_id_and_more",
        ),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Team",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created", models.DateTimeField(auto_now_add=True, db_index=True)),
                ("slug", models.SlugField()),
                ("members", models.ManyToManyField(to=settings.AUTH_USER_MODEL)),
                (
                    "organization",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="teams",
                        to="organizations_ext.organization",
                    ),
                ),
                ("projects", models.ManyToManyField(to="projects.project")),
                (
                    "members_new",
                    models.ManyToManyField(to="organizations_ext.organizationuser"),
                ),
            ],
            options={
                "unique_together": {("slug", "organization")},
            },
        ),
        migrations.RemoveField(
            model_name="team",
            name="members",
        ),
        migrations.RenameField(
            model_name="team",
            old_name="members_new",
            new_name="members",
        ),
        migrations.AlterField(
            model_name="team",
            name="id",
            field=models.BigAutoField(
                auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
            ),
        ),
        migrations.AlterField(
            model_name="team",
            name="members",
            field=models.ManyToManyField(
                blank=True, to="organizations_ext.organizationuser"
            ),
        ),
    ]
